# TODO:
# - some tests fail with tcl8.5, it's tcl fault,
#	if someone REALLY cares (s)he can look into it
# - configure.ac present, but doesn't support all -DEFINES, also it uses bash syntax (var+=value)
#
# Conditional build:
%bcond_with	tests		# run tests
%bcond_with	readline	# readline (GPL) instead of libedit
%bcond_without	tcl		# Tcl extension
%bcond_without	doc		# disable documentation building
%bcond_without	unlock_notify	# disable unlock notify API
%bcond_without	load_extension	# enable load extension API
%bcond_with	icu		# ICU tokenizer support

%ifarch alpha sparc %{x8664}
%undefine	with_tests
%endif

# disabling tcl currently breaks making test target,
# some hack in Makefile needs to be done
%if %{without tcl}
%undefine	with_tests
%endif

# sqlite3 version with zero padded without any dots (3 08 10 01 is 3.8.10.1)
# but trailing 00 means no 4rd part (3 11 01 00 is 3.11.1)
%define		vnum	3220000
%define		ver		%{lua:vn=rpm.expand("%vnum");v="";for i in string.gmatch(string.format("%08d", vn), "..") do v=v.."."..i:gsub("^0", "");end;v=v:gsub("^.",""):gsub("\.0$","");print(v)}

%define		tclver		8.6
Summary:	SQLite3 library
Summary(pl.UTF-8):	Biblioteka SQLite3
Name:		sqlite3
Version:	%{ver}
Release:	1
License:	Public Domain
Group:		Libraries
# Source0Download: http://www.sqlite.org/download.html
Source0:	http://www.sqlite.org/2018/sqlite-src-%{vnum}.zip
# Source0-md5:	af55df181b37829bc10f652b12be7817
Patch0:		%{name}-sign-function.patch
URL:		http://www.sqlite.org/
%{?with_load_extension:Provides:	%{name}(load_extension)}
%{?with_unlock_notify:Provides:	%{name}(unlock_notify)}
%{?with_icu:Provides:	%{name}(icu)}
BuildRequires:	autoconf >= 2.50
BuildRequires:	automake
%{!?with_readline:BuildRequires:	libedit-devel}
BuildRequires:	libtool
%{?with_readline:BuildRequires:	readline-devel}
%{?with_load_extension:BuildRequires:	sed >= 4.0}
BuildRequires:	tcl
%{?with_tcl:BuildRequires:	tcl-devel >= %{tclver}}
BuildRequires:	unzip
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_ulibdir	/usr/lib

%description
SQLite is a C library that implements an SQL database engine. A large
subset of SQL92 is supported. A complete database is stored in a
single disk file. The API is designed for convenience and ease of use.
Applications that link against SQLite can enjoy the power and
flexiblity of an SQL database without the administrative hassles of
supporting a separate database server. Because it omits the
client-server interaction overhead and writes directly to disk, SQLite
is also faster than the big database servers for most operations. In
addition to the C library, the SQLite distribution includes a
command-line tool for interacting with SQLite databases and SQLite
bindings for Tcl/Tk.

%description -l pl.UTF-8
SQLite jest biblioteką języka C, która implementuje silnik baz danych
SQL (obsługiwana jest większość standardu SQL92). Cała baza danych
przechowywana jest w jednym pliku. Aplikacje wykorzystujące tę
bibliotekę charakteryzują się siłą i elastycznością SQLowych baz
danych bez konieczności utrzymywania osobnego serwera baz danych.
Ponieważ pomijana jest komunikacja klient-serwer i dane są zapisywane
bezpośrednio na dysku, SQLite jest szybsza od dużych serwerów
bazodanowych przy większości operacji na bazie danych. Dodatkowo
oprócz biblioteki języka C, dostarczany jest program do zarządzania
bazami danych.

%package devel
Summary:	Header files for SQLite development
Summary(pl.UTF-8):	Pliki nagłówkowe SQLite
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
%if %{with unlock_notify}
Provides:	%{name}-devel(unlock_notify)
%endif
%if %{with load_extension}
Provides:	%{name}-devel(load_extension)
%endif
%if %{with icu}
Provides:	%{name}-devel(icu)
%endif

%description devel
SQLite is a C library that implements an SQL database engine. A large
subset of SQL92 is supported. A complete database is stored in a
single disk file. The API is designed for convenience and ease of use.
Applications that link against SQLite can enjoy the power and
flexiblity of an SQL database without the administrative hassles of
supporting a separate database server. Because it omits the
client-server interaction overhead and writes directly to disk, SQLite
is also faster than the big database servers for most operations. In
addition to the C library, the SQLite distribution includes a
command-line tool for interacting with SQLite databases and SQLite
bindings for Tcl/Tk.

This package contains the header files needed to develop programs that
use these SQLite.

%description devel -l pl.UTF-8
SQLite jest biblioteką języka C, która implementuje silnik baz danych
SQL (obsługiwana jest większość standardu SQL92). Cała baza danych
przechowywana jest w jednym pliku. Aplikacje wykorzystujące tę
bibliotekę charakteryzują się siłą i elastycznością SQLowych baz
danych bez konieczności utrzymywania osobnego serwera baz danych.
Ponieważ pomijana jest komunikacja klient-serwer i dane są zapisywane
bezpośrednio na dysku, SQLite jest szybsza od dużych serwerów
bazodanowych przy większości operacji na bazie danych. Dodatkowo
oprócz biblioteki języka C, dostarczany jest program do zarządzania
bazami danych.

Pakiet zawiera pliki nagówkowe niezbedne do kompilowania programów
używających biblioteki SQLite.

%package static
Summary:	Static libraries for SQLite development
Summary(pl.UTF-8):	Statyczne biblioteki SQLite
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}
%if %{with unclock_notify}
Provides:	%{name}-static(unlock_notify)
%endif
%if %{with load_extension}
Provides:	%{name}-static(load_extension)
%endif

%description static
SQLite is a C library that implements an SQL database engine. A large
subset of SQL92 is supported. A complete database is stored in a
single disk file. The API is designed for convenience and ease of use.
Applications that link against SQLite can enjoy the power and
flexiblity of an SQL database without the administrative hassles of
supporting a separate database server. Because it omits the
client-server interaction overhead and writes directly to disk, SQLite
is also faster than the big database servers for most operations. In
addition to the C library, the SQLite distribution includes a
command-line tool for interacting with SQLite databases and SQLite
bindings for Tcl/Tk.

This package contains the static SQLite libraries.

%description static -l pl.UTF-8
SQLite jest biblioteką języka C, która implementuje silnik baz danych
SQL (obsługiwana jest większość standardu SQL92). Cała baza danych
przechowywana jest w jednym pliku. Aplikacje wykorzystujące tę
bibliotekę charakteryzują się siłą i elastycznością SQLowych baz
danych bez konieczności utrzymywania osobnego serwera baz danych.
Ponieważ pomijana jest komunikacja klient-serwer i dane są zapisywane
bezpośrednio na dysku, SQLite jest szybsza od dużych serwerów
bazodanowych przy większości operacji na bazie danych. Dodatkowo
oprócz biblioteki języka C, dostarczany jest program do zarządzania
bazami danych.

Pakiet zawiera statyczne biblioteki SQLite.

%package -n tcl-%{name}
Summary:	sqlite3 tcl extension
Summary(pl.UTF-8):	Rozszerzenie sqlite3 dla Tcl
Group:		Development/Languages/Tcl

%description -n tcl-%{name}
sqlite3 tcl extension.

%description -n tcl-%{name} -l pl.UTF-8
Rozszerzenie sqlite3 dla Tcl.

%prep
%setup -q -n sqlite-src-%{vnum}
%patch0 -p1

%{__sed} -i 's/mkdir doc/#mkdir doc/' Makefile.in

if [ "$(cat VERSION)" != "%{version}" ]; then
	echo "Tarball content doesn't match version %{version}." >&2
	exit 1
fi

%build
%{__libtoolize}
cp -f /usr/share/automake/config.sub .
%{__aclocal}
%{__autoconf} --force
append-cppflags() {
	CPPFLAGS="$CPPFLAGS $*"
}
append-libs() {
	LIBS="$LIBS $*"
}
export CPPFLAGS="%{rpmcflags}"
export LIBS
%if %{with tcl}
export TCLLIBDIR="%{tcl_sitearch}/sqlite3"
%endif

append-cppflags -DSQLITE_DISABLE_DIRSYNC=1 -DSQLITE_SECURE_DELETE

# Support column metadata functions.
# http://sqlite.org/c3ref/column_database_name.html
# http://sqlite.org/c3ref/table_column_metadata.html
append-cppflags -DSQLITE_ENABLE_COLUMN_METADATA

# Support Full-Text Search versions 3 and 4.
# http://sqlite.org/fts3.html
#append-cppflags -DSQLITE_ENABLE_FTS3 -DSQLITE_ENABLE_FTS3_PARENTHESIS -DSQLITE_ENABLE_FTS4 -DSQLITE_ENABLE_FTS4_UNICODE61
append-cppflags -DSQLITE_ENABLE_FTS3 -DSQLITE_ENABLE_FTS3_PARENTHESIS
append-cppflags -DSQLITE_ENABLE_FTS3_TOKENIZER

# Support R*Trees.
# http://sqlite.org/rtree.html
append-cppflags -DSQLITE_ENABLE_RTREE

# Support soundex() function.
# http://sqlite.org/lang_corefunc.html#soundex
#append-cppflags -DSQLITE_SOUNDEX

# Support dbstat virtual table.
# https://www.sqlite.org/dbstat.html
append-cppflags -DSQLITE_ENABLE_DBSTAT_VTAB

%if %{with unlock_notify}
# Support unlock notification.
# http://sqlite.org/unlock_notify.html
append-cppflags -DSQLITE_ENABLE_UNLOCK_NOTIFY
%endif

%if %{with icu}
append-cppflags -DSQLITE_ENABLE_ICU
append-libs "-licui18n -licuuc"
%endif

%if %{with load_extension}
append-libs "-ldl"
%endif

%configure \
	%{?with_readline:--disable-editline} \
	%{!?with_tcl:--disable-tcl}%{?with_tcl:--with-tcl=%{_ulibdir}} \
	%{__enable_disable load_extension load-extension} \
	--enable-threadsafe \
	--enable-fts5

%{__make}

%if %{with doc}
%{__make} doc
%endif

%{?with_tests:LC_ALL=C %{__make} test}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/%{_lib},%{_bindir},%{_includedir},%{_libdir},%{_mandir}/man1}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%{__mv} $RPM_BUILD_ROOT%{_libdir}/lib*.so.* $RPM_BUILD_ROOT/%{_lib}
%{__rm} $RPM_BUILD_ROOT%{_libdir}/lib*.so
ln -sf /%{_lib}/$(cd $RPM_BUILD_ROOT/%{_lib}; echo lib*.so.*.*) \
	$RPM_BUILD_ROOT%{_libdir}/libsqlite3.so

cp -p sqlite3.1 $RPM_BUILD_ROOT%{_mandir}/man1

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc README.md
%attr(755,root,root) %{_bindir}/sqlite3
%attr(755,root,root) /%{_lib}/libsqlite3.so.*.*.*
%attr(755,root,root) %ghost /%{_lib}/libsqlite3.so.0
%{_mandir}/man1/sqlite3.1*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libsqlite3.so
%{_libdir}/libsqlite3.la
%{_includedir}/sqlite3.h
%{_includedir}/sqlite3ext.h
%{_pkgconfigdir}/sqlite3.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libsqlite3.a

%if %{with tcl}
%files -n tcl-%{name}
%defattr(644,root,root,755)
%dir %{_libdir}/tcl*/sqlite3
%attr(755,root,root) %{_libdir}/tcl%{tclver}/sqlite3/libtclsqlite3.so
%{_libdir}/tcl%{tclver}/sqlite3/pkgIndex.tcl
%endif
%changelog
* Tue Jan 23 2018 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/sqlite3.git;a=log;h=master

* Mon Jan 22 2018 Jan Palus <atler@pld-linux.org> 5e9394c
- up to 3.22.0

* Sun Nov 05 2017 Marcin Banasiak <marcin.banasiak@gmail.com> 4522125
- Enable FTS5. Release 2

* Tue Oct 24 2017 Jan Palus <atler@pld-linux.org> 3fdf8dd
- up to 3.21.0

* Mon Sep 25 2017 Adam Gołębiowski <adamg@pld-linux.org> c75d561
- updated to 3.20.1

* Sun Aug 06 2017 Jan Palus <atler@pld-linux.org> c386019
- up to 3.20.0

* Thu Jul 13 2017 Jakub Bogusz <qboosh@pld-linux.org> 66f41fe
- updated to 3.19.3

* Wed Mar 08 2017 Jakub Bogusz <qboosh@pld-linux.org> 0d754db
- now it uses libedit by default, added bcond to use readline instead

* Tue Mar 07 2017 Jan Palus <atler@pld-linux.org> 937fa54
- up to 3.17.0

* Mon Jan 02 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> adbdd44
- up to 3.16.0

* Wed Dec 28 2016 Jan Palus <atler@pld-linux.org> c06feee
- up to 3.15.2

* Sun Oct 16 2016 Jakub Bogusz <qboosh@pld-linux.org> d1548c2
- updated to 3.15.0

* Sun Sep 11 2016 Elan Ruusamäe <glen@delfi.ee> 5aa51f8
- configure note

* Sun Sep 11 2016 Elan Ruusamäe <glen@delfi.ee> 61a0da0
- enable FTS3_TOKENIZER; needed for clementine 1.3

* Mon Aug 08 2016 Jan Palus <atler@pld-linux.org> 16787c3
- up to 3.14.0

* Wed May 11 2016 Jakub Bogusz <qboosh@pld-linux.org> 8eeb6e4
- updated to 3.12.2[.0]

* Thu Apr 28 2016 Elan Ruusamäe <glen@delfi.ee> 943b1d5
- include 3 in summary

* Mon Mar 07 2016 Jakub Bogusz <qboosh@pld-linux.org> ea9e16e
- updated to 3.11.1

* Sat Jan 16 2016 Jakub Bogusz <qboosh@pld-linux.org> 9a9b047
- updated to 3.10.1

* Tue Oct 27 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 0400167
- up to 3.9.1

* Mon Sep 28 2015 Jan Rękorajski <baggins@pld-linux.org> 806c431
- enable support for  dbstat virtual table (required by firefox / iceweasel)
- rel 3

